<?
class Skilltree {
    
	function getSkillTree(SimpleXMLElement $xml){
        $skills = array();
        // to be safe, sort the skills
        foreach($xml->skills->children() as $node){
			$name = (string) $node->getName();
			$level = (int) $node;
            $skills[$name]=$level;
        }
        ksort($skills);

        // build the tree
        $arr=array(); // temporary
        foreach($skills as $name => $level){
            if($level<=20) $max=20;
            elseif($level<=50) $max=50;
            elseif($level<=100)$max=100;
            elseif($level<=150)$max=150;
            elseif($level<=200)$max=200;
            else $max=250;
            $arr[$name]=array('level' => $level, 'max_level'=>$max, 'childs' => array(), 'is_root'=>true);
            // now find where it belongs to in skilltree
            for($i=strlen($name)-1;$i>0;$i--){
                $sub=substr($name, 0, $i);
                if(isset($arr[$sub])){
                    unset($arr[$name]['is_root']);
                    $arr[$sub]['childs'][$name]=&$arr[$name];
                    break;
                }
            }
		}
        // get the root nodes and 'sort' them in the right order,
        // sub-skills should be ordered correctly
        $tree = array(
            'sf' => $arr['sf'],
            'sm' => $arr['sm'],
            'sc' => $arr['sc'],
            'sh' => $arr['sh'],
        );
        return $tree;
	}
}//Skilltree

/*
 * Example:
 *
<?
    $tree = SkillTree::getSkilltree($xml);

    echo '<div id="skillTree">';
    display_tree($tree);
    echo '</div>';

function display_tree($childs){
   global $api;
   echo '<ul>';
   foreach($childs as $key => $node){
       $txt=$api->translate($key.'.skill', 'en');
       // check if skill is finished, or is not
       if(empty($node['childs']) && $node['level']!=250){
           $class=" unfinished";
       }else{
           $class=' finished';
       }
       echo '<li><span class="node'.$class.'">'.$txt.
                '<span class="skill-level">'.$node['level'].'/'.$node['max_level'].'</span>'.
            '</span>';
       if(!empty($node['childs'])){
           display_tree($node['childs']);
       }
       echo '</li>';
   }
   echo '</ul>';
}
?>
<style type="text/css">
    .node { width: 160px; height: 30px; border: 1px solid black; display: block;
        margin: 1px; font-size: 10px; text-align: center; color: white}
    .skill-level {float: right}
    .hover {background-color: #abcdef}
    .finished {background-color: #747f1f}
    .finished .skill-level { display: none}
    .unfinished{background-color: #8a5617}
</style>

<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3/jquery.min.js"></script>
<script type="text/javascript">
// <![CDATA[
$(function(){
	$("#skillTree").find(".node").css("cursor","pointer").click(function(){
		// show next branch
		$(this).parent().find(">ul").toggle();
	}).end().find("li>ul").hide();

    $("#skillTree .node").hover(function(){
		$(this).addClass("hover");
	},function(){
		$(this).removeClass("hover");
	})
});
// ]]>
</script>
 */

//eof